One data grid for JavaScript, React, Vue & Angular. Sorting, filtering, virtualization, pinning, and CSV export included. Early access $199 $349 → [Get it now]

How to use Apollo Client in React

Apollo Client is the most powerful GraphQL client for React, providing intelligent caching, optimistic updates, subscriptions, and error handling out of the box. As the creator of CoreUI with 25 years of web development experience, I use Apollo Client in data-intensive React dashboards where normalized caching significantly reduces redundant API calls and keeps the UI in sync across components. Beyond useQuery and useMutation, Apollo’s real power lies in its normalized cache — when any component fetches a user, every other component showing that user updates automatically. Understanding the cache is what separates basic Apollo usage from production-grade Apollo usage.

Set up Apollo Client with authentication and error handling.

// apolloClient.js
import {
  ApolloClient,
  InMemoryCache,
  createHttpLink,
  from,
  ApolloLink
} from '@apollo/client'
import { setContext } from '@apollo/client/link/context'
import { onError } from '@apollo/client/link/error'

const httpLink = createHttpLink({ uri: '/graphql' })

const authLink = setContext((_, { headers }) => ({
  headers: {
    ...headers,
    authorization: localStorage.getItem('token')
      ? `Bearer ${localStorage.getItem('token')}`
      : ''
  }
}))

const errorLink = onError(({ graphQLErrors, networkError }) => {
  if (graphQLErrors) {
    graphQLErrors.forEach(({ message, extensions }) => {
      if (extensions?.code === 'UNAUTHENTICATED') {
        localStorage.removeItem('token')
        window.location.href = '/login'
      }
      console.error(`GraphQL Error: ${message}`)
    })
  }
  if (networkError) {
    console.error(`Network Error: ${networkError}`)
  }
})

export const client = new ApolloClient({
  link: from([errorLink, authLink, httpLink]),
  cache: new InMemoryCache()
})

from([errorLink, authLink, httpLink]) chains links in order. Error handling runs first, then auth headers are added, then the HTTP request is made. The onError link intercepts GraphQL and network errors globally.

Optimistic Updates

Update the UI immediately before the server responds.

import { useMutation, gql, useApolloClient } from '@apollo/client'

const TOGGLE_LIKE = gql`
  mutation ToggleLike($postId: ID!) {
    toggleLike(postId: $postId) {
      id
      liked
      likeCount
    }
  }
`

function LikeButton({ postId, liked, likeCount }) {
  const [toggleLike] = useMutation(TOGGLE_LIKE, {
    variables: { postId },
    optimisticResponse: {
      toggleLike: {
        __typename: 'Post',
        id: postId,
        liked: !liked,
        likeCount: liked ? likeCount - 1 : likeCount + 1
      }
    }
  })

  return (
    <button onClick={() => toggleLike()}>
      {liked ? '❤️' : '🤍'} {likeCount}
    </button>
  )
}

optimisticResponse provides an expected result that Apollo writes to the cache immediately. If the mutation succeeds, the real response replaces it. If it fails, Apollo rolls back to the previous state automatically.

Pagination with fetchMore

Load more items on demand.

import { useQuery, gql } from '@apollo/client'

const GET_POSTS = gql`
  query GetPosts($offset: Int!, $limit: Int!) {
    posts(offset: $offset, limit: $limit) {
      id
      title
      author
    }
    postCount
  }
`

function PostList() {
  const { data, loading, fetchMore } = useQuery(GET_POSTS, {
    variables: { offset: 0, limit: 10 }
  })

  function loadMore() {
    fetchMore({
      variables: { offset: data.posts.length, limit: 10 },
      updateQuery: (prev, { fetchMoreResult }) => {
        if (!fetchMoreResult) return prev
        return {
          ...prev,
          posts: [...prev.posts, ...fetchMoreResult.posts]
        }
      }
    })
  }

  return (
    <div>
      {data?.posts.map(p => <div key={p.id}>{p.title}</div>)}
      {data?.posts.length < data?.postCount && (
        <button onClick={loadMore} disabled={loading}>Load More</button>
      )}
    </div>
  )
}

fetchMore makes an additional query and merges the results using updateQuery. This pattern implements infinite scroll or “load more” pagination without replacing the existing results.

Best Practice Note

This is the advanced Apollo usage pattern referenced in CoreUI React dashboard templates. For the cache to work correctly, every __typename + id combination must be unique across your API — Apollo uses this for normalization. Configure InMemoryCache with typePolicies when your types use a non-id primary key or require custom merge strategies. See how to use GraphQL in React for the basic setup, including the plain fetch alternative.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Ship internal tools in hours, not weeks. Real auth, users, jobs, audit logs, and cohesive UI included. Early access $289 $499 → [Get it now]

How to use Apollo Client in Vue

Using Apollo Client in Vue provides a comprehensive GraphQL solution with intelligent caching, optimistic updates, and reactive query management for enterprise-grade applications. As the creator of CoreUI with extensive Vue experience since 2014, I’ve implemented Apollo Client in numerous enterprise applications for sophisticated data management and real-time user experiences. The most effective approach involves integrating Apollo Client with Vue 3 using the official Vue Apollo plugin for reactive queries and seamless state management. This method provides advanced caching strategies while maintaining excellent developer experience through declarative query composition and automatic UI updates.

Integrate Apollo Client with Vue using @vue/apollo-composable for reactive GraphQL queries and intelligent caching.

import { createApp } from 'vue'
import { ApolloClient, InMemoryCache, createHttpLink } from '@apollo/client/core'
import { DefaultApolloClient, provideApolloClient } from '@vue/apollo-composable'
import { gql } from '@apollo/client/core'

// Apollo Client setup
const httpLink = createHttpLink({
    uri: 'http://localhost:4000/graphql',
    headers: {
        authorization: `Bearer ${localStorage.getItem('token')}`
    }
})

const cache = new InMemoryCache({
    typePolicies: {
        User: {
            fields: {
                posts: {
                    merge(existing = [], incoming) {
                        return [...existing, ...incoming]
                    }
                }
            }
        }
    }
})

const apolloClient = new ApolloClient({
    link: httpLink,
    cache,
    defaultOptions: {
        watchQuery: {
            errorPolicy: 'all'
        }
    }
})

// Vue app setup
const app = createApp(App)
app.provide(DefaultApolloClient, apolloClient)
provideApolloClient(apolloClient)

// GraphQL operations
const GET_USERS = gql`
    query GetUsers($first: Int!, $after: String) {
        users(first: $first, after: $after) {
            edges {
                node {
                    id
                    name
                    email
                    avatar
                    posts {
                        id
                        title
                        content
                        createdAt
                    }
                }
                cursor
            }
            pageInfo {
                hasNextPage
                endCursor
            }
        }
    }
`

const CREATE_POST = gql`
    mutation CreatePost($input: CreatePostInput!) {
        createPost(input: $input) {
            id
            title
            content
            author {
                id
                name
            }
            createdAt
        }
    }
`

// Vue component with Apollo Client
import { useQuery, useMutation } from '@vue/apollo-composable'
import { ref, computed } from 'vue'

export default {
    setup() {
        const first = ref(10)
        const after = ref(null)

        // Query with reactive variables
        const { result, loading, error, refetch, fetchMore } = useQuery(
            GET_USERS,
            () => ({
                first: first.value,
                after: after.value
            }),
            {
                errorPolicy: 'all',
                fetchPolicy: 'cache-and-network'
            }
        )

        // Computed users from query result
        const users = computed(() =>
            result.value?.users?.edges?.map(edge => edge.node) ?? []
        )

        const pageInfo = computed(() =>
            result.value?.users?.pageInfo
        )

        // Mutation for creating posts
        const { mutate: createPost, loading: createPostLoading } = useMutation(
            CREATE_POST,
            {
                update(cache, { data: { createPost } }) {
                    // Update cache after mutation
                    const query = {
                        query: GET_USERS,
                        variables: { first: first.value, after: after.value }
                    }

                    const data = cache.readQuery(query)
                    if (data?.users?.edges) {
                        const authorEdge = data.users.edges.find(
                            edge => edge.node.id === createPost.author.id
                        )
                        if (authorEdge) {
                            authorEdge.node.posts.push(createPost)
                            cache.writeQuery({ ...query, data })
                        }
                    }
                }
            }
        )

        // Load more users (pagination)
        const loadMore = async () => {
            if (pageInfo.value?.hasNextPage) {
                await fetchMore({
                    variables: {
                        after: pageInfo.value.endCursor
                    }
                })
            }
        }

        // Create new post with optimistic response
        const handleCreatePost = async (postData) => {
            try {
                await createPost({
                    input: postData
                }, {
                    optimisticResponse: {
                        createPost: {
                            __typename: 'Post',
                            id: 'temp-id',
                            title: postData.title,
                            content: postData.content,
                            author: {
                                __typename: 'User',
                                id: postData.authorId,
                                name: 'Current User'
                            },
                            createdAt: new Date().toISOString()
                        }
                    }
                })
            } catch (err) {
                console.error('Failed to create post:', err)
            }
        }

        return {
            users,
            loading,
            error,
            pageInfo,
            createPostLoading,
            loadMore,
            handleCreatePost,
            refetch
        }
    }
}

This code demonstrates comprehensive Apollo Client integration with Vue using the official Apollo Vue composition functions for reactive queries, mutations with cache updates, and pagination support. Apollo Client provides intelligent caching with automatic UI updates, optimistic responses for immediate feedback, and sophisticated cache management through update functions. The integration leverages Vue’s reactivity system for seamless data binding while maintaining Apollo’s powerful GraphQL features.

Best Practice Note:

This is the Apollo Client architecture we implement in CoreUI enterprise applications for robust GraphQL data management with advanced caching strategies. Configure cache policies appropriately for your data patterns and implement error boundaries for comprehensive error handling in production applications.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

One data grid for JavaScript, React, Vue & Angular. Sorting, filtering, virtualization, pinning, and CSV export included. Early access $199 $349 → [Get it now]

How to use Apollo Client in Angular

Apollo Client provides powerful GraphQL client with normalized caching, optimistic UI updates, and reactive queries for sophisticated data management in Angular. As the creator of CoreUI, a widely used open-source UI library, I’ve integrated Apollo Angular in enterprise applications. The most effective approach is using apollo-angular package which provides Angular-specific Apollo Client integration with observables and dependency injection. This method enables automatic cache updates, real-time subscriptions via WebSocket, and efficient data normalization across components.

Install apollo-angular and configure Apollo Client with GraphQL endpoint and cache policy for reactive data fetching.

npm install @apollo/client apollo-angular graphql

Setup Apollo Client module:

import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core'
import { provideHttpClient } from '@angular/common/http'
import { APOLLO_OPTIONS, ApolloModule } from 'apollo-angular'
import { HttpLink } from 'apollo-angular/http'
import { InMemoryCache, ApolloClientOptions } from '@apollo/client/core'

export function apolloOptionsFactory(httpLink: HttpLink): ApolloClientOptions<any> {
  return {
    link: httpLink.create({
      uri: 'https://api.example.com/graphql'
    }),
    cache: new InMemoryCache({
      typePolicies: {
        Query: {
          fields: {
            users: {
              merge(existing = [], incoming) {
                return incoming
              }
            }
          }
        }
      }
    }),
    defaultOptions: {
      watchQuery: {
        fetchPolicy: 'cache-and-network',
        errorPolicy: 'all'
      },
      query: {
        fetchPolicy: 'network-only',
        errorPolicy: 'all'
      },
      mutate: {
        errorPolicy: 'all'
      }
    }
  }
}

export const appConfig: ApplicationConfig = {
  providers: [
    provideZoneChangeDetection({ eventCoalescing: true }),
    provideHttpClient(),
    {
      provide: APOLLO_OPTIONS,
      useFactory: apolloOptionsFactory,
      deps: [HttpLink]
    }
  ]
}

Using Apollo in services:

import { Injectable } from '@angular/core'
import { Apollo, gql } from 'apollo-angular'
import { Observable, map } from 'rxjs'

interface User {
  id: string
  name: string
  email: string
  posts: Post[]
}

interface Post {
  id: string
  title: string
  content: string
}

const GET_USER = gql`
  query GetUser($id: ID!) {
    user(id: $id) {
      id
      name
      email
      posts {
        id
        title
        content
      }
    }
  }
`

const GET_USERS = gql`
  query GetUsers($limit: Int!, $offset: Int!) {
    users(limit: $limit, offset: $offset) {
      id
      name
      email
    }
  }
`

const CREATE_POST = gql`
  mutation CreatePost($title: String!, $content: String!) {
    createPost(title: $title, content: $content) {
      id
      title
      content
    }
  }
`

const UPDATE_USER = gql`
  mutation UpdateUser($id: ID!, $name: String!, $email: String!) {
    updateUser(id: $id, name: $name, email: $email) {
      id
      name
      email
    }
  }
`

const DELETE_POST = gql`
  mutation DeletePost($id: ID!) {
    deletePost(id: $id)
  }
`

@Injectable({
  providedIn: 'root'
})
export class UserService {
  constructor(private apollo: Apollo) {}

  getUser(id: string): Observable<User> {
    return this.apollo
      .watchQuery<{ user: User }>({
        query: GET_USER,
        variables: { id }
      })
      .valueChanges.pipe(
        map(result => result.data.user)
      )
  }

  getUsers(limit: number = 10, offset: number = 0): Observable<User[]> {
    return this.apollo
      .query<{ users: User[] }>({
        query: GET_USERS,
        variables: { limit, offset }
      })
      .pipe(
        map(result => result.data.users)
      )
  }

  createPost(title: string, content: string): Observable<Post> {
    return this.apollo
      .mutate<{ createPost: Post }>({
        mutation: CREATE_POST,
        variables: { title, content },
        update: (cache, { data }) => {
          // Update cache after mutation
          if (data?.createPost) {
            cache.modify({
              fields: {
                posts(existingPosts = []) {
                  const newPostRef = cache.writeFragment({
                    data: data.createPost,
                    fragment: gql`
                      fragment NewPost on Post {
                        id
                        title
                        content
                      }
                    `
                  })
                  return [...existingPosts, newPostRef]
                }
              }
            })
          }
        }
      })
      .pipe(
        map(result => result.data!.createPost)
      )
  }

  updateUser(id: string, name: string, email: string): Observable<User> {
    return this.apollo
      .mutate<{ updateUser: User }>({
        mutation: UPDATE_USER,
        variables: { id, name, email },
        optimisticResponse: {
          updateUser: {
            __typename: 'User',
            id,
            name,
            email
          }
        }
      })
      .pipe(
        map(result => result.data!.updateUser)
      )
  }

  deletePost(id: string): Observable<boolean> {
    return this.apollo
      .mutate<{ deletePost: boolean }>({
        mutation: DELETE_POST,
        variables: { id },
        update: (cache) => {
          cache.evict({ id: `Post:${id}` })
          cache.gc()
        }
      })
      .pipe(
        map(result => result.data!.deletePost)
      )
  }
}

Using Apollo service in components:

import { Component, OnInit } from '@angular/core'
import { CommonModule } from '@angular/common'
import { UserService } from './user.service'

@Component({
  selector: 'app-users-list',
  standalone: true,
  imports: [CommonModule],
  template: `
    <div class='users-container'>
      <h2>Users</h2>

      <div *ngIf='loading' class='loading'>
        Loading users...
      </div>

      <div *ngIf='error' class='error'>
        {{ error.message }}
      </div>

      <div class='users-grid'>
        <div *ngFor='let user of users' class='user-card'>
          <h3>{{ user.name }}</h3>
          <p>{{ user.email }}</p>
          <button (click)='viewUser(user.id)'>View Profile</button>
        </div>
      </div>

      <div class='pagination'>
        <button
          (click)='loadPrevious()'
          [disabled]='offset === 0'
        >
          Previous
        </button>
        <button (click)='loadNext()'>
          Next
        </button>
      </div>
    </div>
  `
})
export class UsersListComponent implements OnInit {
  users: any[] = []
  loading = false
  error: any = null
  limit = 10
  offset = 0

  constructor(private userService: UserService) {}

  ngOnInit() {
    this.loadUsers()
  }

  loadUsers() {
    this.loading = true
    this.error = null

    this.userService.getUsers(this.limit, this.offset).subscribe({
      next: (users) => {
        this.users = users
        this.loading = false
      },
      error: (err) => {
        this.error = err
        this.loading = false
      }
    })
  }

  loadNext() {
    this.offset += this.limit
    this.loadUsers()
  }

  loadPrevious() {
    this.offset = Math.max(0, this.offset - this.limit)
    this.loadUsers()
  }

  viewUser(id: string) {
    // Navigate to user profile
  }
}

Here the apollo-angular package provides Apollo Client integration with Angular’s dependency injection and RxJS observables. The InMemoryCache normalizes GraphQL responses by type and ID for efficient caching. The gql tag parses GraphQL query strings into document nodes for Apollo Client. The watchQuery creates observable that emits on cache updates and network responses. Mutations with update function manually modify cache after successful mutation. Optimistic responses update UI immediately before server response arrives. The cache.evict removes specific entities from normalized cache after deletion.

Best Practice Note:

This is the Apollo Client setup we use in CoreUI Angular applications requiring sophisticated GraphQL data management with caching and real-time updates. Define GraphQL fragments for reusable field sets across queries, implement pagination with fetchMore for infinite scrolling, use subscriptions with apollo-angular subscriptions for real-time data updates via WebSocket, and leverage Apollo DevTools browser extension for cache inspection and query debugging during development.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.

Answers by CoreUI Core Team